<?php

/** ----------------------------------------------------------------------------
 *
 * Konsistenz-Check für Webs / ECB - Shops
 *
 * Mit diesem Script können überflüssige Kategorie- und Produktbilder gelöscht
 * werden. Ebenfalls listet das Script fehlende Bilder auf.
 *
 * Die Datei wir im root-Verzeichnis des Shop angelegt und aufgerufen.
 * Vor der Verwendung sollte dringend ein Index auf die Tabellen
 * products_images und image_name gesetzt werden.
 *
 * Getestet mit: ECB-Online-Shop v 1.0.8
 *
 * -----------------------------------------------------------------------------
 * Die Verwendung der Software geschieht auf eigene Gefahr. Vor der Benutzung
 * sind Sicherungen der Daten anzulegen.
 *
 * Solange wie die Copyright - Angaben im Code verbleiben, darf dieser
 * unentgeldlich genutzt und weiterverbreitet werden.
 * (Über einen Link freue ich mich.)
 *
 * @author Mike Küster <mike@xantiva.de>
 * @version 0.1
 * @copyright 2011 Mike Küster http://www.xantiva.de/
 *
 * -----------------------------------------------------------------------------
 */
require_once 'includes/application_top.php';


$reservedFilenames = array('.', '..', '.htaccess', 'index.html', 'noimage.gif');

// noimage.gif wird in der product.php definiert


function IsMainPicture($imageName)
{
    $mainPictureSQL = '-- konsistenz-check.php
            SELECT COUNT(*) FROM ' . TABLE_PRODUCTS . '
            WHERE `products_image` = \'' . $imageName . '\'';
    $mainPictureQuery = xtc_db_query($mainPictureSQL);
    $mainPicture = xtc_db_fetch_array($mainPictureQuery);

    if ($mainPicture["COUNT(*)"] > 0) {
        return true;
    } else {
        return false;
    }
}

function IsAdditionalPicture($imageName)
{
    $zusatzBilderSQL = '-- konsistenz-check.php
            SELECT COUNT(*) FROM ' . TABLE_PRODUCTS_IMAGES . '
            WHERE `image_name` = \'' . $imageName . '\'';
    $zusatzBilderQuery = xtc_db_query($zusatzBilderSQL);
    $zusatzBilder = xtc_db_fetch_array($zusatzBilderQuery);

    if ($zusatzBilder["COUNT(*)"] > 0) {
        return true;
    } else {
        return false;
    }
}

function IsCategoryPicture($imageName)
{
    $categoryPictureSQL = '-- konsistenz-check.php
            SELECT COUNT(*) FROM ' . TABLE_CATEGORIES . '
            WHERE `categories_image` = \'' . $imageName . '\'';
    $categoryPictureQuery = xtc_db_query($categoryPictureSQL);
    $categoryPicture = xtc_db_fetch_array($categoryPictureQuery);

    if ($categoryPicture["COUNT(*)"] > 0) {
        return true;
    } else {
        return false;
    }
}

function CleanProductImageFolder($dir)
{
    global $reservedFilenames;

    $files1 = scandir($dir);
    echo 'Verzeichnis: ' . $dir . ' => ' . count($files1) . ' Dateien/Verzeichnisse<br>';

    $i = 0;
    foreach ($files1 as $value) {
        set_time_limit(5);
        if (!in_array($value, $reservedFilenames)) {
            if (!IsMainPicture($value) && !IsAdditionalPicture($value)) {
                unlink($dir . '/' . $value);
                $i++;
            }
        }
    }
    echo $i . ' obsolete Bilder gefunden und gelöscht!<br>';
}

function CheckForMissingProductImages($dirs)
{

    echo 'missing files:<br>';
    $productImagesSQL = '-- konsistenz-check.php
        SELECT `products_image` FROM ' . TABLE_PRODUCTS . ' WHERE `products_image` != "" ';
    $productImagesQuery = xtc_db_query($productImagesSQL);
    while ($row = xtc_db_fetch_array($productImagesQuery)) {
        CheckIfFileIsMissing($row['products_image'], $dirs);
    }

    $productImagesSQL = '-- konsistenz-check.php
        SELECT `image_name` FROM ' . TABLE_PRODUCTS_IMAGES . ' WHERE `image_name` != "" ';
    $productImagesQuery = xtc_db_query($productImagesSQL);
    while ($row = xtc_db_fetch_array($productImagesQuery)) {
        CheckIfFileIsMissing($row['image_name'], $dirs);
    }
}

function CheckForMissingCategoryImages()
{

    $dirs = array('categories' => 'images/categories');
    echo 'missing files:<br>';
    $categoryImagesSQL = '-- konsistenz-check.php
        SELECT `categories_image` FROM ' . TABLE_CATEGORIES . ' WHERE `categories_image` != "" ';
    $categoryImagesQuery = xtc_db_query($categoryImagesSQL);
    while ($row = xtc_db_fetch_array($categoryImagesQuery)) {
        CheckIfFileIsMissing($row['categories_image'], $dirs);
    }
}

function CheckIfFileIsMissing($filename, $dirs)
{
    foreach ($dirs as $value) {
        if (!file_exists($value . '/' . $filename)) {
            echo $value . '/' . $filename . '<br>';
        }
    }
}

function CleanCategoryImagesFolder()
{
    global $reservedFilenames;

    $dir = 'images/categories';

    $files1 = scandir($dir);
    echo 'Verzeichnis: ' . $dir . ' => ' . count($files1) . ' Dateien/Verzeichnisse<br>';

    $i = 0;
    foreach ($files1 as $value) {
        set_time_limit(5);
        if (!in_array($value, $reservedFilenames)) {
            if (!IsCategoryPicture($value)) {
                unlink($dir . '/' . $value);
                $i++;
            }
        }
    }
    echo $i . ' obsolete Bilder gefunden und gelöscht!<br>';
}

/**
 * MAIN
 */
$productImageDirs = array(
    'info' => 'images/product_images/info_images',
    'original' => 'images/product_images/original_images',
    'popup' => 'images/product_images/popup_images',
    'thumbnail' => 'images/product_images/thumbnail_images'
);

foreach ($productImageDirs as $value) {
    CleanProductImageFolder($value);
}

CheckForMissingProductImages($productImageDirs);

CleanCategoryImagesFolder();

CheckForMissingCategoryImages();
